searchNodes=[{"doc":"AWS Secrets Manager ConfigProvider for Elixir Releases.","ref":"SecretsManagerProvider.html","title":"SecretsManagerProvider","type":"module"},{"doc":"Struct for managing configurations like :client and :parser.","ref":"SecretsManagerProvider.Configuration.html","title":"SecretsManagerProvider.Configuration","type":"module"},{"doc":"Returns a new Configuration struct with defaults.","ref":"SecretsManagerProvider.Configuration.html#new/0","title":"SecretsManagerProvider.Configuration.new/0","type":"function"},{"doc":"","ref":"SecretsManagerProvider.Configuration.html#t:t/0","title":"SecretsManagerProvider.Configuration.t/0","type":"type"},{"doc":"Default Secrets Manager client used by SecretsManagerProvider. This client uses ExAws.SecretsManager library and implements the SecretsManagerProvider.SecretsManagerClient behaviour.","ref":"SecretsManagerProvider.ExAwsClient.html","title":"SecretsManagerProvider.ExAwsClient","type":"module"},{"doc":"A generic behaviour to implement Secret Manager Client for SecretsManagerProvider.","ref":"SecretsManagerProvider.SecretsManagerClient.html","title":"SecretsManagerProvider.SecretsManagerClient","type":"behaviour"},{"doc":"","ref":"SecretsManagerProvider.SecretsManagerClient.html#c:get_secrets/1","title":"SecretsManagerProvider.SecretsManagerClient.get_secrets/1","type":"callback"},{"doc":"Utilities for converting Maps to Keywords and atomizing keys.","ref":"SecretsManagerProvider.Utils.html","title":"SecretsManagerProvider.Utils","type":"module"},{"doc":"","ref":"SecretsManagerProvider.Utils.html#to_atom/1","title":"SecretsManagerProvider.Utils.to_atom/1","type":"function"},{"doc":"","ref":"SecretsManagerProvider.Utils.html#to_keyword/1","title":"SecretsManagerProvider.Utils.to_keyword/1","type":"function"},{"doc":"SecretsManagerProvider Secrets Manager Provider is an Elixir Release provider that loads runtime configurations from AWS Secrets Manager.","ref":"readme.html","title":"SecretsManagerProvider","type":"extras"},{"doc":"Add secrets_manager_provider to your deps/0 in your mix.exs file. A TOML (toml) or JSON (jason) library will also need to be included. This can be any library, as long as it implements decode!/1. defp deps do {:secrets_manager_provider, &quot;~&gt; 0.5&quot;}, {:toml, &quot;~&gt; 0.6&quot;} end","ref":"readme.html#installation","title":"SecretsManagerProvider - Installation","type":"extras"},{"doc":"Elixir toml is the default parser library used by Secrets Manager Provider. Feel free to swap this out with a library of your choice. config :secrets_manager_provider, :parser, Jason AWS ExAws is the default client used to get secrets from AWS Secrets Manager. Configuration options for ExAws can be found here. The action secretsmanager:GetSecretValue must be added to your IAM Role or User. Below is an example of this policy: { &quot;Version&quot;: &quot;2012-10-17&quot;, &quot;Statement&quot;: [ { &quot;Sid&quot; : &quot;Stmt2GetSecretValue&quot;, &quot;Effect&quot;: &quot;Allow&quot;, &quot;Action&quot;: [ &quot;secretsmanager:GetSecretValue&quot; ], &quot;Resource&quot;: &quot;arn:aws:secretsmanager:&lt;region&gt;:&lt;account_id&gt;:secret:&lt;secret-name&gt;&quot;, &quot;Condition&quot; : { &quot;ForAnyValue:StringLike&quot; : { &quot;secretsmanager:VersionStage&quot; : &quot;AWSCURRENT&quot; } } } ] }","ref":"readme.html#configuration","title":"SecretsManagerProvider - Configuration","type":"extras"},{"doc":"Add the following to your mix.exs configuration. In this example, the name of the app is :example. def project do [ app: :example, ... releases: [ example: [ config_providers: [{SecretsManagerProvider, {:name, &quot;name&quot;}] ] ] ] end The name of the secret sorted in AWS Secrets Manager can provided in in two ways. Provide the name directly in the release configurations by using the tuple {:name, &quot;secret/name&quot;} for the provider. Provide the name of a ENV variable where the secret name can be found, {:env, &quot;secret/name&quot;}. This option is useful when your release is run in different environments. Make sure the ENV variable is set on the machine or container before starting the release. You can store your runtime configurations in AWS Secrets Manager in any format. Below are two examples with TOML and JSON. Toml (Default) [example] somekey = &quot;key&quot; [example.&quot;Example.Repo&quot;] url = &quot;ecto://postgres:postgres@localhost/example_dev&quot; JSON { &quot;example&quot;: { &quot;Example.Repo&quot;: { &quot;url&quot;: &quot;ecto://postgres:postgres@localhost/example_dev&quot;} } } The keys are converted to atoms, and the result are merged with existing configs.","ref":"readme.html#usage","title":"SecretsManagerProvider - Usage","type":"extras"},{"doc":"(https://travis-ci.org/christopherlai/secrets_manager_provider.svg?branch=master) (https://img.shields.io/hexpm/v/secrets_manager_provider.svg?style=flat)","ref":"readme.html#code-status","title":"SecretsManagerProvider - Code Status","type":"extras"},{"doc":"The MIT License (MIT) Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"SecretsManagerProvider - License","type":"extras"}]